function y=dtheta2(x)
%y=dtheta2(x)
%
%y = grad f(x) + rho*grad alpha*alpha,
%kde grad f(x) = [4*x(1)^3 + 2*x(1); 2*x(2)],
%    grad h(x) = [-2 -1; -3 1];
%    grad alpha(x)_1 = [0;0],  if -2*x(1) - 3*x(2) - 1<=0 | grad h(x)_(1,:), if -2*x(1) - 3*x(2) - 1>0
%    grad alpha(x)_2 = [0;0],  if -x(1) + x(2) + 5<=0 | grad h(x)_(2,:), if -x(1) + x(2) + 5>0

global rho

h(1,1) = -2*x(1) - 3*x(2) - 1;
h(2,1) = -x(1) + x(2) + 5;

alpha=max(h, 0);

gf = [4*x(1)^3 + 2*x(1); 2*x(2)];
gh = [-2 -1; -3 1];

if alpha(1)==0
   galpha(:,1)=zeros(2,1);
else
   galpha(:,1)=gh(:,1);
end;

if alpha(2)==0
   galpha(:,2)=zeros(2,1);
else
   galpha(:,2)=gh(:,2);
end;

y = gf + rho*galpha*alpha;


