function [x,it]=subgradient(subgr,x0,tol)
% [x,it] = subgradient(subgr,x0,tol)
%
% function minimizes nonsmooth function fun
%
% x  ... searched minimum
% it ... number of iterations
%
% subgr  ... arbitrary subgradient of function fun at x  
% x0      ... starting point
% tol      ... stopping criterion

epsilon=1e-12;

x=x0;
it = 1;
t=1/it;
g=feval(subgr,x);
if norm(g)>epsilon
    xn = x - t*g/norm(g);
else
    xn = x - t*g/epsilon;
end


while norm(xn-x) >= tol 

  it = it + 1;
  x = xn ;
  t=1/it;
  g=feval(subgr,x);
  if norm(g)>epsilon
      xn = x - t*g/norm(g);
  else
      xn = x - t*g/epsilon;
  end

end

x = xn;

% end