function [x,it]=zlatyrez(fun,a,b,tol)

%[x,it]=zlatyrez(fun,a,b,tol)
%
% funkce nalezne minimum funkce f(x)
% na intervalu <a,b> metodou zlateho rezu
%
% x ... minimum
% it ... pocet iteraci
%
% fun ... f(x)
% a,b ... meze intervalu
% tol ... pozadovana absolutni presnost


koef=1/2 + sqrt(5)/2;

a0=a; b0=b;

d0=(b0-a0)/koef + a0;
c0=a0+b0-d0;

it=0;

an=a0;
bn=b0;
cn=c0;
dn=d0;

fcn=feval(fun,cn);
fdn=feval(fun,dn);


while bn-an > tol
   a=an; b=bn; 
   c=cn; d=dn;
   
   fc=fcn; fd=fdn;
   
   %Pokud se poloha d lisi od spravne polohy d je nutno
   %znovu vypocist c a d 
   if abs(d - ((b-a)/koef + a))>tol/10
      d=(b-a)/koef + a;
      c=a+b-d;
      
      fc=feval(fun,c);
      fd=feval(fun,d);
   end;
   
   if fc < fd
      an=a; bn=d; dn=c; cn=an+bn-dn; x=dn;
      fcn=feval(fun,cn); fdn=fc;
   elseif fd < fc	
      an=c; bn=b; cn=d; dn=an+bn-cn; x=cn;
      fcn=fd; fdn=feval(fun,dn);
   elseif fc == fd
      an=c; bn=d; dn=(bn-an)/koef + an; cn=an+bn-dn;
      fcn=feval(fun,cn); fdn=feval(fun,dn);
      if fcn < fdn
         x=cn;
      else
         x=dn;
      end;
   end;
   
   
   it=it+1;
end;

