function [x,it]=gradient(fun,dfun,x0,tol)
%[x,it] = gradient(fun,dfun,x0,tol)
%
% function minimizes function fun
%
% x  ... searched minimum
% it ... number of iterations
%
% fun  ... function fun 
% dfun  ... gradient of function fun at x  
% x0      ... starting point
% tol      ... stopping criterion

epsilon=1e-12;

x=x0;
it = 1;

g=feval(dfun,x);
gnorm=norm(g);
if norm(g)<=epsilon
    gnorm=epsilon;
end

d=-g/gnorm;
%line search
t=zlatyrez(fun,0,1,x,d,tol);

xn = x + t*d;


while norm(xn-x) >= tol %norm(fxn-fx) >= tol %gnorm >= tol

  it = it + 1;
  x = xn ;
 
  g=feval(dfun,x);
  gnorm=norm(g);
  if norm(g)<=epsilon
      gnorm=epsilon;
  end

  d=-g/gnorm;
  %line search
  t=zlatyrez(fun,0,1,x,d,tol);

  xn = x + t*d;
  

end

x = xn;

% end