function [x] = bisekce(grad,Hess,delta,a,b,tol)

% [x] = bisekce(grad,Hess,delta,a,b,tol)
%
% funkce nalezne reseni rovnice 
% || -(Hess+x*I)\grad || = delta
% na intervalu <a,b> metodou puleni intervalu
%
% x ... reseni rovnice
%
% grad,Hess,delta ... data rovnice
% a,b ... meze intervalu
% tol ... pozadovana absolutni presnost

if a>b
  an=b;
  bn=a;
else
  an=a;
  bn=b;
end;

while (bn - an) >= tol 
   a=an; b=bn;
   c=0.5*(a+b);
   
   if ( norm( (Hess+a*eye(size(Hess)))\grad,2 ) - delta ) * ( norm( (Hess+c*eye(size(Hess)))\grad,2 ) - delta ) < 0
     an=a; bn=c;
   elseif ( norm( (Hess+c*eye(size(Hess)))\grad,2 ) - delta ) * ( norm( (Hess+b*eye(size(Hess)))\grad,2 ) - delta ) < 0	
     an=c; bn=b;
   else
     an=c; bn=c;
   end;

end

x = c;

% end